      subroutine diff1tc
     *(nca,ica,ncb,icb,nt,it,ispt,np,ip,ispp,iadr1,
     *b,ab)
      parameter(maxsym=8,maxorbcas=16)
      include 'maxorb.prm'
      IMPLICIT REAL*8(A-H,O-X,Z),logical*1(y)
c    |-*-*-*-*-*-*-*-|-*-*-*-*-*-*-*-|
c    |      b        |      ab       |
c
      common/dim/iadri ; integer(8) iadri
      common/opt/ihab,calcul
      character*3 calcul
      common/sym/ itsym(maxorb*2),its(maxsym,maxsym),nsym
      common /orb/ enuc,eref,norb,noca,nocb
     *,iorb(2*maxorb),ninac,nvirt,noca0
      common/orb2/numina(maxorb),numvir(maxorb),iordo(maxorb*2)
     *,iodro(maxorb*2)
     *,numinb(maxorb),numvib(maxorb)
      common/l40/ hmono(maxorb*(maxorb+1)/2),aj(maxorb*(maxorb+1)/2)
     *,ak(maxorb*(maxorb+1)/2),f(maxorb*(maxorb+1)/2),e0
     *,ajk(maxorb*(maxorb+1)/2),escf
      common/sy2/nts(maxsym),ncs(maxsym),nps(maxsym)
     *,norbs(maxsym)
      common /prep/ nca0,ncb0,ic0(maxorbcas),icamun(maxorb+maxorb)
     *,numt(maxorb),nump(maxorb),nv
     *,gener,yoc(maxorb+maxorb),yrefc(maxorbcas),yac(maxorb)
     *,ygmono,ygddci,ygddc2,ygcas,ygtous
      character*4 gener
      dimension ica(maxorbcas),icb(maxorbcas),it(2),ip(2)
      dimension ittemp(maxorb)
      dimension ictemp(maxorb)
      dimension b(iadri),ab(iadri)
      common/test/itest(100)
      yw=.false.
c
c-----------------------------------------------------------
c     une difference  suppression 1 trou 1 electron CAS
c-----------------------------------------------------------
c
      nta=(nt+ispt)/2
      npa=(np+ispp)/2
      ntb=nt-nta
      npb=np-npa
      ynon=.false.
      b0=b(iadr1)
c     iif(yw)write(6,*)'nca,ncb,nca0,ncb0
      if(gener.eq.'PERT'.or.gener.eq.'DDci'.or.ygmono
     *.or.gener.eq.'MR') then
         if(iabs(nca-1-ncb-nca0+ncb0).gt.2) goto 9
      else if(gener.eq.'DDCI'.or.gener.eq.'DDC2') then
         if(iabs(nca-1-ncb-nca0+ncb0).gt.3) goto 9
      endif
      do 1 i=1,nta
c--------it(i) est le trou supprime
      is1=itsym(it(i))
      if(yw)write(6,*)'diff1tc trou a supprime',it(i)
c-----------boucle sur l'electron supprime
      do 2 j=1,nca
      if(is1.ne.itsym(ica(j))) goto 2
      if(yw)write(6,*)'diff1tc electron a supprime',ica(j)
c--------------ica(j) est l'electron supprimee
      do k=1,i-1
         ittemp(k)=it(k)
      enddo
      do k=1,j-1
         ictemp(k)=ica(k)
      enddo
      do k=i+1,nt
         ittemp(k-1)=it(k)
      enddo
      do k=j+1,nca
         ictemp(k-1)=ica(k)
      enddo
      if(gener(1:2).eq.'MR')
     *call accept(nca-1,ictemp,ncb,icb,nt-1,np,ynon)
      if(ynon) goto 1
      call adrdet
     *(nca-1,ictemp,ncb,icb,nt-1,ittemp,
     *ispt-1,np,ip,ispp,iadr2,
     *      mhdum,mtdum)
c--------------calcul de l'integrale
      mini=min(ica(j),it(i))
      maxi=max0(ica(j),it(i))
      a=f(maxi*(maxi-1)/2+mini)
c------------------
c------------------signe
c                  on a supprime le trou i et l'el CAS j
c                  on a donc ramene l'el j a la place i
c                  l'el a donc saute
c                  - par dessus j-1 el du CAS
c                  - par dessus ninac-ica(i)-(nca-i) occupees
c
c                             occ                           CAS
c                              i                               j
c                        x x x   x x   x                 x x x x x x
c                              |_______________________________|
c                        <---ninac----->
c                              <------->
c                              ninac-ita(i)
c                      donc    ninac-ita(i)-(nta-i) electrons
c------------------
      isgn=1-2*mod(ninac+iodro(it(i))+(nta+i)+j+1,2)
      if(yw)write(6,*)'diff1tc adresses,int',iadr1,iadr2,a
      if(calcul.eq.'M') then
         call stover(iadr1,iadr2,a*isgn)
      else
         aa=a*isgn
CYSGN               if(.not.yeqy(ysgn(iadr1),ysgn(iadr2))) aa=-aa
CIT17           if(itest(17).eq.iadr2)write(6,'('' diff1tc it17'',i5,2f1
CIT17        *   iadr1,aa,b(iadr1)
CIT17           if(itest(17).eq.iadr1)write(6,'('' diff1tc it17'',i5,2f1
CIT17        *   iadr2,aa,b(iadr2)
         ab(iadr2)=ab(iadr2)+aa*b0
         ab(iadr1)=ab(iadr1)+aa*b(iadr2)
      endif
 2    continue
 1    continue
 9    continue
      if(gener.eq.'PERT'.or.gener.eq.'DDci'.or.ygmono
     *.or.gener.eq.'MR') then
         if(iabs(nca-ncb+1-nca0+ncb0).gt.2) return
      else if(gener.eq.'DDCI'.or.gener.eq.'DDC2') then
         if(iabs(nca-ncb+1-nca0+ncb0).gt.3) return
      endif
      do 3 i=nta+1,nt
c--------it(i) est le trou supprime
      is1=itsym(it(i))
      if(yw)write(6,*)'diff1tc trou b supprime',it(i)
c-----------boucle sur l'electron supprime
      do 4 j=1,ncb
      if(is1.ne.itsym(icb(j))) goto 4
      if(yw)write(6,*)'diff1tc electron b supprime',icb(j)
c--------------icb(j) est l'electron supprime
      do k=1,i-1
         ittemp(k)=it(k)
      enddo
      do k=1,j-1
         ictemp(k)=icb(k)
      enddo
      do k=i+1,nt
         ittemp(k-1)=it(k)
      enddo
      do k=j+1,ncb
         ictemp(k-1)=icb(k)
      enddo
      if(gener(1:2).eq.'MR')
     *call accept(nca,ica,ncb-1,ictemp,nt-1,np,ynon)
      if(ynon) goto 4
      call adrdet
     *(nca,ica,ncb-1,ictemp,nt-1,ittemp,
     *ispt+1,np,ip,ispp,iadr2,
     *      mhdum,mtdum)
c--------------calcul de l'integrale
      mini=min(icb(j),iorb(it(i)))
      maxi=max0(icb(j),iorb(it(i)))
      a=f(maxi*(maxi-1)/2+mini)
c------------------
c------------------signe (v. commentaires + haut
      isgn=1-2*mod(ninac+iodro(iorb(it(i)))+(ntb+i+nta)+j+1,2)
      if(yw)
     *write(6,*)'ninac,iorb(it(i)),iodro(iorb(it(i))),ntb,i,nta,j',
     *ninac,iorb(it(i)),iodro(iorb(it(i))),ntb,i,nta,j
      if(yw)write(6,*)'diff1tc adresses,int',iadr1,iadr2,a,isgn
      if(calcul.eq.'M') then
         call stover(iadr1,iadr2,a*isgn)
      else
         aa=a*isgn
CYSGN               if(.not.yeqy(ysgn(iadr1),ysgn(iadr2))) aa=-aa
CIT17           if(itest(17).eq.iadr2)write(6,'('' diff1tc it17'',i5,2f1
CIT17        *   iadr1,aa,b(iadr1)
CIT17           if(itest(17).eq.iadr1)write(6,'('' diff1tc it17'',i5,2f1
CIT17        *   iadr2,aa,b(iadr2)
         ab(iadr2)=ab(iadr2)+aa*b0
         ab(iadr1)=ab(iadr1)+aa*b(iadr2)
      endif
 4    continue
 3    continue
      return
      end
